#include <stdio.h>

#include "test/Test.h"
#include "tests/ArrayListTests.h"
#include "tests/ArrayStringTests.h"
#include "tests/ArrayTests.h"
#include "tests/BitArrayTests.h"
#include "tests/BoxTests.h"
#include "tests/ComponentsTests.h"
#include "tests/HashMapTests.h"
#include "tests/LinkedListTests.h"
#include "tests/ListTests.h"
#include "tests/MathTests.h"
#include "tests/MatrixTests.h"
#include "tests/QuaternionTests.h"
#include "tests/RingBufferTests.h"
#include "tests/StackTests.h"
#include "tests/UniquePointerTests.h"
#include "tests/UtilityTests.h"
#include "tests/VectorTests.h"
#include "utils/Utility.h"

static void onExit(int code, void* data) {
    unsigned int i = *static_cast<unsigned int*>(data);
    printf("Hello from exit %d: 0x%x\n", code, i);
}

int main() {
    Core::ArrayListTests::test();
    Core::ArrayStringTests::test();
    Core::ArrayTests::test();
    Core::BitArrayTests::test();
    Core::BoxTests::test();
    Core::ComponentsTests::test();
    Core::HashMapTests::test();
    Core::LinkedListTests::test();
    Core::ListTests::test();
    Core::MathTests::test();
    Core::MatrixTests::test();
    Core::QuaternionTests::test();
    Core::RingBufferTests::test();
    Core::StackTests::test();
    Core::UniquePointerTests::test();
    Core::UtilityTests::test();
    Core::VectorTests::test();

    Core::Test::finalize();

    unsigned int data = 0x1234;
    Core::setExitHandler(onExit, &data);
    CORE_EXIT(0);

    return 0;
}
